﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Design
{
    public partial class Block : UserControl
    {
        private Designer win;

        public Block (Designer win)
        {
            this.win = win;
            InitializeComponent();
            this.BackgroundImageLayout = ImageLayout.Stretch;
        }

        private void setColorMenuItem_Click(object sender, EventArgs e)
        {
            if (colorDialog.ShowDialog() == DialogResult.OK)
            {
                this.BackColor = colorDialog.Color;
            }
        }

        private void setImageMenuItem_Click(object sender, EventArgs e)
        {
            if (openDialog.ShowDialog () == DialogResult.OK)
            {
                this.BackgroundImage = new Bitmap (openDialog.FileName);
             
            }
        }

        private void stretchMenuItem_Click (object sender, EventArgs e)
        {
            stretchMenuItem.Checked = ! stretchMenuItem.Checked;
        }

        private void stretchMenuItem_CheckedChanged (object sender, EventArgs e)
        {
            if (stretchMenuItem.Checked)
                BackgroundImageLayout = ImageLayout.Stretch;
            else
                BackgroundImageLayout = ImageLayout.None;
        }


        private void Block_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            win.selectObject(this);
        }

        private int X0, Y0;
        private bool down = false;

        private void Block_MouseDown (object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            down = true;
        }

        private void Block_MouseMove (object sender, MouseEventArgs e)
        {
            if (down)
            {
                if (e.Button == MouseButtons.Middle ||
                    e.Button == MouseButtons.Left && ModifierKeys == Keys.Control)
                {
                    // resize
                    this.Width += e.X - X0;
                    this.Height += e.Y - Y0;
                    X0 = e.X;
                    Y0 = e.Y;
                }
                else
                {
                    // move
                    this.Left += e.X - X0;
                    this.Top += e.Y - Y0;
                }
            }
        }

        private void contextMenu_Opening(object sender, CancelEventArgs e)
        {

        }

        private void Block_MouseUp (object sender, MouseEventArgs e)
        {
            down = false;
        }



    }
}
